#define _CRT_SECURE_NO_WARNINGS

#include "TextBox.h"
#include "RegexBox.h"
#include "OnigRegex.h"
#include <vector>

using namespace std;

static HINSTANCE hRtLib;
HWND hEdit;
vector<string> AllRecievedLog; // tB^[ŎMSẴO(SJIS)

HWND CreateTextBox(HWND hWnd, HINSTANCE hInst ) {

	int iClientWidth = 0;
	int iClientHeight = 0;

	RECT rc;
	GetClientRect(hWnd, &rc); // NCAg̈̃TCY

	// ]NCAg̈̃TCYEBhETCYvZ
	iClientWidth = (rc.right - rc.left);
	iClientHeight = (rc.bottom - rc.top);

	hRtLib = LoadLibrary("RICHED32.DLL");
	hEdit = CreateWindowEx(WS_EX_CLIENTEDGE,
		"RICHEDIT",
		"",
		WS_CHILD | WS_VISIBLE | WS_BORDER | ES_MULTILINE |
		WS_VSCROLL | WS_HSCROLL | ES_AUTOVSCROLL | ES_AUTOHSCROLL,
		TextBoxPosX, TextBoxPosY,
		iClientWidth-TextBoxPosX*2, iClientHeight-TextBoxPosY-TextBoxPosX, //Ƃ肠AÕEBhE
		hWnd,
		(HMENU)1,
		hInst,
		NULL);


	// ƁAEM_UPDATE 悤ɂ邽߁B
	ChangeBackColor( hEdit, 0x330000 );
	SetInitialFont(hEdit);

	//b`GfBbgRg[̍ő啶̃Zbg
    SendMessage(hEdit, EM_EXLIMITTEXT, 0, (LPARAM)TextBoxLimitSize);

	return hEdit;
}

void DeleteTextBox() {
	DestroyWindow(hEdit);
	if(FreeLibrary(hRtLib) == 0) {
		MessageBox(NULL, "Cus", "Error", MB_OK);
	}
}

void MoveTextBox(HWND hWnd) {
	int iClientWidth = 0;
	int iClientHeight = 0;

	RECT rc;
	GetClientRect(hWnd, &rc); // NCAg̈̃TCY

	// ]NCAg̈̃TCYEBhETCYvZ
	iClientWidth = (rc.right - rc.left);
	iClientHeight = (rc.bottom - rc.top);

	// ړ
	MoveWindow(hEdit, TextBoxPosX, TextBoxPosY, iClientWidth-TextBoxPosX*2, iClientHeight-TextBoxPosY-TextBoxPosX, true);
}


static DWORD dwMyMask; //CHARFORMATŎg}XNl


static BOOL SetInitialFont(HWND hEdit)//ŏ̃tHg̐ݒ
{
	CHARFORMAT cfm;
	memset(&cfm, 0, sizeof(CHARFORMAT));
	cfm.cbSize = sizeof(CHARFORMAT);
	cfm.dwMask = CFM_BOLD | CFM_CHARSET | CFM_COLOR |
		CFM_FACE | CFM_ITALIC | CFM_SIZE | CFM_STRIKEOUT |
		CFM_UNDERLINE;
	dwMyMask = cfm.dwMask;//ȌdwMyMask̒lg
	cfm.bCharSet = SHIFTJIS_CHARSET;
	cfm.yHeight = 9*20; // 9 |Cg
	cfm.crTextColor = (COLORREF)0xffffff;
	strcpy(cfm.szFaceName, "lr SVbN");
	if (SendMessage(hEdit, EM_SETCHARFORMAT, SCF_SELECTION | SCF_WORD, (LPARAM)&cfm) == 0) {
		MessageBox(hEdit, "EM_SETCHARFORMATsł", "Error", MB_OK);
		return FALSE;
	}
	return TRUE; 
}

BOOL SetForegroundFont(HWND hEdit)
{
	CHARFORMAT cfm;
	CHOOSEFONT cf;
	LOGFONT lf;
	HDC hDC;

	memset(&cf, 0, sizeof(CHOOSEFONT));
	memset(&lf, 0, sizeof(LOGFONT));
	cfm.cbSize = sizeof(CHARFORMAT);


	//܂ł̐ݒ擾ĂCHOOSEFONT\̂ɓn
	SendMessage(hEdit, EM_GETCHARFORMAT, TRUE, (LPARAM)&cfm);
	hDC = GetDC(hEdit);
	lf.lfHeight = MulDiv(cfm.yHeight,
		GetDeviceCaps(hDC, LOGPIXELSY), -1440);
	ReleaseDC(hEdit, hDC);
	cfm.dwMask = dwMyMask;
	if (cfm.dwEffects & CFE_BOLD)
		lf.lfWeight = FW_BOLD;
	else
		lf.lfWeight = FW_NORMAL;
	if (cfm.dwEffects & CFE_ITALIC)
		lf.lfItalic = TRUE;
	if (cfm.dwEffects & CFE_UNDERLINE)
		lf.lfUnderline = TRUE;
	if (cfm.dwEffects & CFE_STRIKEOUT)
		lf.lfStrikeOut = TRUE;
	lf.lfCharSet = cfm.bCharSet;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = cfm.bPitchAndFamily;
	strcpy( lf.lfFaceName, cfm.szFaceName );
	cf.rgbColors = cfm.crTextColor;
	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = hEdit;
	cf.lpLogFont = &lf;
	cf.Flags = CF_SCREENFONTS | CF_EFFECTS | CF_INITTOLOGFONTSTRUCT;

	//tHgI_CAOoĐVݒ擾
	if (ChooseFont(&cf))
	{
		cfm.cbSize = sizeof(CHARFORMAT);
		cfm.dwMask = dwMyMask;
		cfm.yHeight = 2 * cf.iPointSize;
		cfm.dwEffects = 0;
		if (lf.lfWeight >= FW_BOLD)
			cfm.dwEffects |= CFE_BOLD;
		if (lf.lfItalic)
			cfm.dwEffects |= CFE_ITALIC;
		if (lf.lfUnderline)
			cfm.dwEffects |= CFE_UNDERLINE;
		if (lf.lfStrikeOut)
			cfm.dwEffects |= CFE_STRIKEOUT;
		cfm.crTextColor = (COLORREF)cf.rgbColors;
		cfm.bPitchAndFamily = lf.lfPitchAndFamily;
		cfm.bCharSet = lf.lfCharSet;
		strcpy(cfm.szFaceName, lf.lfFaceName);
		if(SendMessage(hEdit, EM_SETCHARFORMAT, 
			SCF_SELECTION, (LPARAM)&cfm) == 0) {
				MessageBox(hEdit, "sł", "Error", MB_OK);
				return FALSE;
		}
	}
	SetFocus(hEdit);
	return TRUE;
}


BOOL ChangeBackColor( HWND hEdit, COLORREF clr )
{
	SendMessage( hEdit, EM_SETBKGNDCOLOR, (WPARAM)0, (LPARAM)clr);

	return TRUE;
}


BOOL WriteRichEdit(HWND hEdit, char* pszBuf)
{
	//GfBbgׂĂ̒̕擾
	int len = SendMessage(hEdit,WM_GETTEXTLENGTH,0,0);
	// ŌɈړ
	SendMessage( hEdit, EM_SETSEL, len, len );

	// ܂ŃXN[
	SendMessage( hEdit, EM_LINESCROLL, 0, AllRecievedLog.size() );

	// K\ɏł
	if ( hRgxEditContent && strlen(hRgxEditContent) > 0 ) {

		// Ƀ}b`ꍇEditBoxɏ
		if ( OnigMatch( pszBuf, hRgxEditContent ) ) {
			SendMessage( hEdit, EM_REPLACESEL, FALSE, (LPARAM)(LPCTSTR)pszBuf );
		}

	// i荞݂ȂS
	} else {
		SendMessage( hEdit, EM_REPLACESEL, FALSE, (LPARAM)(LPCTSTR)pszBuf );
	}

	return TRUE;
}


BOOL ReWriteAllRichEdit(HWND hEdit) {

	// ŏɃJ[\ړ
    SendMessage( hEdit, EM_SETSEL,(WPARAM)0,(LPARAM)0 );

	SendMessage( hEdit, WM_SETTEXT, (WPARAM)0, (LPARAM)0 );

	// tHg߂Đݒ
	SetInitialFont( hEdit );

	for each ( string line in AllRecievedLog) {
		// K\̂Ƃ뒆gȂSB
		if ( strlen( hRgxEditContent ) == 0 ) {
			WriteRichEdit(hEdit, (char *)line.c_str() );

		// ȊOȂ琳K\Ƀ}b`̂̂݁B
		} else if ( OnigMatch( line.c_str(), hRgxEditContent ) ) {
			WriteRichEdit(hEdit, (char *)line.c_str() );
		}
	}

	// ܂ŃXN[
	SendMessage( hEdit, EM_LINESCROLL, 0, AllRecievedLog.size() );

	return TRUE;
}


BOOL ClearRichEdit(HWND hEdit) {

	// ŏɃJ[\ړ
    SendMessage( hEdit, EM_SETSEL,(WPARAM)0,(LPARAM)0 );

	SendMessage( hEdit, WM_SETTEXT, (WPARAM)0, (LPARAM)0 );

	// tHg߂Đݒ
	SetInitialFont( hEdit );

	AllRecievedLog.clear();

	return TRUE;
}


